#undef FLOAT
#include <dsound.h>
#include <windows.h>

/* around 200/2ms at 48KHz/16b/stereo */
#define BUFFERSIZE (1024*4*10/2)

static LPDIRECTSOUND8 fd;
static LPDIRECTSOUNDBUFFER buf;

static void some_silence(void)
{
  LPVOID wr;
  DWORD len;
  HRESULT err;

  err = buf->lpVtbl->Lock(buf,0,0,&wr,&len,NULL,NULL,DSBLOCK_ENTIREBUFFER);
  if (err != DS_OK) abort();
  if (len != BUFFERSIZE) abort();
  memset(wr, 0, BUFFERSIZE);
  err = buf->lpVtbl->Unlock(buf, wr, len, NULL, 0);
  if (err != DS_OK) abort();
}

int snd_pcm_open(void *x, ...)
{
  extern HWND microsoft_window;
  //extern volatile int microsoft_window_created;
  HRESULT err;
  WAVEFORMATEX wfx;
  DSBUFFERDESC bufdesc;

//  while (microsoft_window_created != 1) Sleep(50);
//while (!microsoft_window_created) Sleep(10);

  /* gstreamer saved my ass on this one - have audio playback continue
   * even when losing focus in the video window
   * gstreamer to write win32 stuff... some kind of weird feeling
   */
  err = DirectSoundCreate8(NULL, &fd, NULL); if (err != DS_OK) abort();
//err = IDirectSound_SetCooperativeLevel(fd,GetDesktopWindow(),DSSCL_NORMAL | DSBCAPS_GLOBALFOCUS);
  err = fd->lpVtbl->SetCooperativeLevel(fd,GetDesktopWindow(),DSSCL_PRIORITY);
  //err = fd->lpVtbl->SetCooperativeLevel(fd, microsoft_window, DSSCL_NORMAL | DSBCAPS_GLOBALFOCUS);
  //err = fd->lpVtbl->SetCooperativeLevel(fd, microsoft_window, DSSCL_PRIORITY);
  //err = fd->lpVtbl->SetCooperativeLevel(fd, GetForegroundWindow(), DSSCL_PRIORITY);
  if (err != DS_OK) abort();

  memset(&wfx, 0, sizeof(WAVEFORMATEX)); 
  wfx.wFormatTag = WAVE_FORMAT_PCM; 
  wfx.nChannels = 2; 
  wfx.wBitsPerSample = 16;
  wfx.nSamplesPerSec = 48000; 
  wfx.nBlockAlign = 4;
  wfx.nAvgBytesPerSec = 48000 * 4; 

  memset(&bufdesc, 0, sizeof(DSBUFFERDESC)); 
  bufdesc.dwSize = sizeof(DSBUFFERDESC); 
  bufdesc.dwFlags = /*DSBCAPS_CTRLPOSITIONNOTIFY |*/
                    DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_GLOBALFOCUS;
  bufdesc.dwBufferBytes = BUFFERSIZE;
  bufdesc.lpwfxFormat = &wfx;

  err = fd->lpVtbl->CreateSoundBuffer(fd, &bufdesc, &buf, NULL);
  if (err != DS_OK) abort();

  some_silence();

  err = buf->lpVtbl->SetCurrentPosition(buf, 0); if (err != DS_OK) abort();

  err = buf->lpVtbl->Play(buf, 0, 0, DSBPLAY_LOOPING);
  if (err != DS_OK) abort();

  return 0;
}

int snd_pcm_close(void *x)
{
  buf->lpVtbl->Stop(buf);
  buf->lpVtbl->Release(buf);
  fd->lpVtbl->Release(fd);
  fd = NULL;
  buf = NULL;
  return 0;
}

static int nextpos = 0;

static int get_free_frames(void)
{
  int free_space, free_frames;
  DWORD rpos, wpos;
  HRESULT err;
  err = buf->lpVtbl->GetCurrentPosition(buf, &rpos, &wpos);
  if (err != DS_OK) abort();
  wpos = nextpos;
  free_space = (int)rpos - (int)wpos;
  if (free_space < 0) free_space += BUFFERSIZE;
  free_frames = free_space / 4;
  return free_frames;
}

int snd_pcm_writei(void *x, void *data, int frames)
{
//printf("snd_pcm_writei %p %p %d\n", x, data, frames);
  int nbytes = frames * 4;
  void *p1, *p2;
  int free_frames;
  DWORD n1, n2;
  HRESULT err;

restart:
  free_frames = get_free_frames();
  if (free_frames < frames) { Sleep(20); goto restart; }

//again:
  //err=buf->lpVtbl->Lock(buf,0,nbytes,&p1,&n1,&p2,&n2,DSBLOCK_FROMWRITECURSOR);

  err=buf->lpVtbl->Lock(buf,nextpos,nbytes,&p1,&n1,&p2,&n2,0);
  if (err != DS_OK) abort();
#if 0
  if (n1+n2 != nbytes) {
printf("DIfF!\n");
    err = buf->lpVtbl->Unlock(buf, p1, 0, p2, 0); if (err != DS_OK) abort();
    Sleep(10);
    goto again;
  }
#endif
  if (n1+n2 != nbytes) abort();
nextpos += nbytes;
nextpos %= BUFFERSIZE;

//printf("n1 %ld n2 %ld p1 %p p2 %p\n", n1, n2, p1, p2);
  memcpy(p1, data, n1);
  memcpy(p2, data+n1, n2);
  err = buf->lpVtbl->Unlock(buf, p1, n1, p2, n2); if (err != DS_OK) abort();
//Sleep(18);
  return frames;
}

int snd_pcm_delay(void *x, snd_pcm_sframes_t *fr)
{
  *fr = BUFFERSIZE/4 - get_free_frames();
  return 0;
}
